#!/bin/sh

# don't let anyone kill us
trap '' 1 2 3 15

logger -p user.info "Starting Lasso8Service"

pid_file=/tmp/LassoService8.pid
hour=-1
restartcounter=0
maxrestarts=20

while [ $restartcounter -lt $maxrestarts ]; do

	#	reset the counter each hour

	if [ $hour -ne `date +%H` ]; then
		restartcounter=0
		hour=`date +%H`
	fi

	#	Start up Lasso8Service.  If it dies, we can see later if it was a clean quit or not

#	MAGICK_HOME=/usr/local/Lasso\ Professional\ 8/ImageMagick-6.0.8
#	export MAGICK_HOME

	LD_LIBRARY_PATH="/usr/lib/jvm/jre/bin/classic:/usr/lib/jvm/java/jre/bin"
	export LD_LIBRARY_PATH

	LC_ALL=en_US
	export LC_ALL
	HOME=/usr/local/Lasso\ Professional\ 8
	export HOME

	umask 002

	cd "${HOME}"/
	sudo -u lasso env LD_LIBRARY_PATH="/usr/lib/jvm/jre/lib/amd64:/usr/lib/jvm/jre/lib/amd64/server:/usr/lib/jvm/jre/lib/i386:/usr/lib/jvm/jre/lib/i386/server" ./Lasso8Service > /tmp/LassoService8.out 2>&1

	#	If there's a dangling pid file, that means we died unexpectedly

	if [ -f "$pid_file" ]; then
		restartcounter=$((restartcounter+1))
		logger -p user.info "Lasso8Service restarted after quitting unexpectedly ${restartcounter} times this hour"
	else
		logger -p user.info "Lasso8Service was shut down cleanly"
		restartcounter=0
		break
	fi

done

#	On exit, check why we're exiting  (if it's bad, let someone know)
if [ $restartcounter = $maxrestarts ]; then
	logger -p user.info "Lasso8Service was restarted ${restartcounter} times in one hour, indicating a more serious configuration problem.  Quitting permanently now."
fi
