<?LassoScript

	Define_Tag: 'Records', -Namespace='ChartFX_',
			-Optional='ReturnField',
			-Optional='ExcludeField',
			-Optional='Fields',
			-Optional='Inverse';
		Local: '_fields' = (Local_Defined: 'fields') && #fields->(IsA: 'array') ? #fields | Field_Names;
		Fail_If: #_fields->size == 0, -1, 'No fields found for [ChartFX_Records]';
		Local: '_return' = (Local_Defined: 'returnfield') ? (Params->(Find: -ReturnField)->(ForEach: {Params->First = Params->First->Second; Return: True}) &) | @#_fields;
		Local: '_exclude' = (Local_Defined: 'excludefield') ? (Params->(Find: -ExcludeField)->(ForEach: {Params->First = Params->First->Second; Return: True}) &) | Array;
		Local: '_output' =  Array;
		If: (Local_Defined: 'Inverse') && (#Inverse !== False);
			Iterate: #_fields, (Local: '_field');
				((#_return >> #_field) && (#_exclude !>> #_field)) ? #_output->(Insert: (Array: #_field));
			/Iterate;
			Iterate: Records_Array, (Local: '_record');
				Iterate: #_fields, (Local: '_field');
					((#_return >> #_field) && (#_exclude !>> #_field)) ? #_output->(Get: Loop_Count)->(Insert: #_record->(Get: Loop_Count));
				/Iterate;
			/Iterate;
		Else;
			Local: '_temp' = Array;
			Iterate: #_fields, (Local: '_field');
				((#_return >> #_field) && (#_exclude !>> #_field)) ? #_temp->(Insert: #_field);
			/Iterate;
			#_output->(Insert: #_temp);
			Iterate: Records_Array, (Local: '_record');
				Local: '_temp' = Array;
				Iterate: #_fields, (Local: '_field');
					((#_return >> #_field) && (#_exclude !>> #_field)) ? #_temp->(Insert: #_record->(Get: Loop_Count));
				/Iterate;
				#_output->(Insert: #_temp);
			/Iterate;
		/If;
		Return: @#_output;
	/Define_Tag;

	// [..._Serve] tags.
	//
	// These tags serve a 'file' in place of the output of the current format file.  They can be used instead
	// of a [Redirect_URL] to serve a different file, can be used to serve a PDF or XML file created in memory,
	// or can be used to serve an image file from a database field.
	//
	// Each tag sets the contents of the page in __http_header__ to an appropriate value and then resets the
	// headers of the page with the file name and MIME type.  Finally, [Abort] is called to prevent further
	// processing of the page.
	//
	// 'content' - The first parameter is the content of the file to be served.
	// -File - Optional parameter which specifies the name of the file to be served.
	// -Type - Optional parameter which specifies the MIME type of the content to be served.
	// -Charset - Optional parameter which specifies the charset of the content to be served.  If passed as boolean, default charset used.
	// -Inline - Optional parameter which specifies the content to be served as 'inline' instead of 'attachment'.

	Define_Tag: 'Serve',
			-Namespace='ChartFX_',
			-Priority='Replace',
			-Required='content',
			-Optional='file',
			-Optional='type',
			-Optional='disposition';
	
		if: !(Local_Defined: 'type');
			Local: 'type' = 'image/png';
		/if;
	
		If: !(Local_Defined: 'file');
			Local: 'file' = Response_FilePath->(split: '/')->last + '.png';
		/if;
	
		if: (local_defined:'inline');
			local: 'disposition' = 'inline';
		else: !(local_defined: 'disposition');
			local: 'disposition' = 'attachment';
		/if;
	
		If: #content->properties->second >> 'data';
			File_Serve:
					-content = #content->data,
					-file = (string: #file),
					-type = (string: #type),
					-disposition = (string: #disposition);
		Else;
			File_Serve:
					-content = #content,
					-file = (string: #file),
					-type = (string: #type),
					-disposition = (string: #disposition);
		/If;
	/Define_Tag;

?>