<?LassoScript

	//
	// [HTTP_GetFile]
	//
	// Overriding built in tag so that it works
	//

	define_tag('GetFile',
		-namespace = 'HTTP_',
		-priority = 'replace',
		-required = 'URL',
		-optional = 'File',
		-optional = 'Username',
		-optional = 'Password',
		-optional = 'Binary');

		error_push;
	
		local(
			'_un' = string(local('username')),
			'_pw' = string(local('password')),
			'_curlparams' = array,
			'_data' = null);

		fail_if(
			(!local_defined('binary')) && (!local_defined('file')),
			-9951,
			'HTTP_GetFile: -File parameter is required when not using -Binary parameter');

		protect;

			#_curlparams->(insert: #URL);

			if(#_un->size);
				#_curlparams->(insert: -Username = @#_un);
				if(!#_pw->size);
					#_curlparams->(insert: -Password = @#_pw);
				/if;
			/if;

			if(#_pw->size);
				#_curlparams->(insert: -Password = @#_pw);
				if(!#_un->size);
					#_curlparams->(insert: -Username = @#_un, 1);
				/if;
			/if;

			#_data = \include_url->run(-params=#_curlparams);

			fail_if(
				error_code != 0,
				error_code,
				'HTTP_GetFile: ' error_msg);

			if(!local_defined('Binary'));

				file_create(#File, -fileoverwrite);

				fail_if(
					file_currenterror(-errorcode) != 0,
					file_currenterror(-errorcode),
					'HTTP_GetFile: ' file_currenterror);

				file_write(#File, #_data);

				fail_if(
					file_currenterror(-errorcode) != 0,
					file_currenterror(-errorcode),
					'HTTP_GetFile: ' file_currenterror);

			/if;

			handle_error;
				error_push;
			/handle_error;

		/protect;

		error_pop;
		
		if(local_defined('Binary') && #_data->isa('bytes'));
			return(#_data);
		else;
			return(null);
		/if;

	/define_tag;

?>