<?LassoScript

	/*
		Library of routines to perform interesting TCP functions like [Stock_Quote]

		History:
		10/23/2007  FMS - Rewrote the tag to use [Include_URL]
		06/23/2004	AJR - Rewrote the tag to use the NET tags rather than the TCP_... tags.
		06/08/2004	FMS - Moved to on-demand library with namespaces
		10/17/2001	GLH - moved return value to prevent leakage of 9 handles on Windows
		01/17/2001	GLH - use new substring search syntax
		          	GLH - use new parameter-passing syntax
		          	GLH - change Tag to Define_Tag
		11/22/2000	GLH - Initial work
	*/


	/*
		Problems:
			Relies on Yahoo!

		Inputs:
			-Ticker:	string, such as "AAPL" or "SMSI" indicates which stock to get info for

		Outputs:
			Text from Yahoo! stock-quote engine, dollar value of stock requested
	*/


	Define_Tag('Quote',
			-Required='Ticker',
			-NameSpace='_global_Stock',
			-priority='replace');

		local: 'result' = (include_url: 'http://quote.yahoo.com/d/quotes.csv?s=' + encode_stricturl(#ticker) + '&f=l1');
		#result = decimal(#result);
		#result->(setformat: -precision=2);
		Return(@#result);

	/Define_Tag;

?>