[

	// String_FindBlocks
	// Author: Adam Randall
	// Date: 4/26/2005
	// Version: 1.0.0

	define_tag('FindBlocks',
		-namespace = '_global_String_',
		-description = 'This tag will find a variable sized block inside of the data provided. This tag is designed for speed inside of large sets of data.',
		-required = 'Start',
		-required = 'End',
		-required = 'Data',
		-optional = 'IgnoreComments',
		-optional = 'CommentChar');

		local(
			'_data' = #Data,
			'_sPos' = -1,
			'_nPos' = -1,
			'_ePos' = -1,
			'groups' = array
		);

		local_remove('Data');

		if(local_defined('IgnoreComments'));
			#_data = string_replaceregexp(-find = '\\r\\n|\\r|\\n', -replace = '\n', #_data)->split('\n');

			if(local_defined('CommentChar'));
				local('_commentchar' = string(#CommentChar));
			else;
				local('_commentchar' = '#');
			/if;

			iterate(#_data, local('i'));
				#i = string_replaceregexp(-find = #_commentchar '.*', -replace = '', #i);
			/iterate;

			#_data->removeall('');

			#_data = #_data->join('\n');
		/if;

		#_sPos = #_data->find(#Start, #_ePos);
		#_ePos = #_data->find(#End);
			#_nPos = #_data->find(#Start, #_sPos + 1);

		if(#_ePos < #_sPos);
			#_ePos = #_data->find(#End, #_sPos);
		/if;

		fail_if(!#_sPos, -9956, 'FindBlocks: Start value not found');
		fail_if(!#_ePos, -9956, 'FindBlocks: End value not found');

		#_ePos = -1;

		while(#_sPos && #_ePos && (loop_count <= #_data->size / (#Start->size + #End->size)));

			#_sPos = #_data->find(#Start, #_ePos + 0);
			if((#_nPos == 0) && (loop_count > 1));
				#_nPos = #_data->find(#Start, #_sPos + 1);
			/if;
			#_ePos = #_data->find(#End,   #_ePos + 1);

			if(#_ePos < #_sPos);
				#_ePos = #_data->find(#End, #_sPos);
			/if;

			while(#_nPos && (#_ePos > #_nPos) && (loop_count <= #_data->size / (#Start->size + #End->size)));
				#_sPos = #_nPos;
				#_nPos = -1;

				#_nPos = #_data->find(#Start, #_sPos + 1);
			/while;

			if((#_sPos > 0) && (#_ePos > 0));
				#groups->insert(#_data->substring(#_sPos, #_ePos - #_sPos + #End->size));
			/if;
		/while;

		return(#groups);

	/define_tag;

]