#!/bin/sh

LASSOHOME="/usr/local/Lasso Professional 8"

if [ `id -u` != 0 ]; then
	echo ""
	sudo -p "You must have administrator privileges to run this script.  Enter the password for %u: " "$0" "$@"
else
	echo ""

	if [ "$1" = "safe" ]; then
		TYPE="SAFE"
	else
		TYPE="NORMAL"
	fi

	running=`ps axc | awk "{ if ( \\$5 == \\"Lasso8Service\\" ) print \\$1 }" | tr '\n' '|' | sed -e 's/^\([0-9]*\).*/\1/'`

	if [  $running ]; then
		echo "Another instance of Lasso 8.6 Service is already running."
		echo ""
		echo "Stopping other Lasso 8.6 Service."
		/usr/sbin/lasso8ctl stop > /dev/null 2>&1
		echo ""
	fi

	echo "Starting Lasso 8.6 Service in console mode."
	echo ""
	echo "Use Control-C or close the terminal window to close Lasso8Service."

#	MAGICK_HOME=/usr/local/Lasso\ Professional\ 8.6/ImageMagick-6.0.8
#	export MAGICK_HOME

	LD_LIBRARY_PATH="/usr/lib/jvm/jre/lib/amd64:/usr/lib/jvm/jre/lib/amd64/server:/usr/lib/jvm/jre/lib/i386:/usr/lib/jvm/jre/lib/i386/server"
	export LD_LIBRARY_PATH

	LC_ALL=en_US
	export LC_ALL
	HOME=/usr/local/Lasso\ Professional\ 8
	export HOME
	umask 002

	if [ "$TYPE" = "SAFE" ]; then
		find "${LASSOHOME}" \
			-maxdepth 3 \
			\( -iname "*.so" -or -iname "*.bundle" \) \
			-exec chmod 000 "{}" \; > /dev/null 2>&1
	else
		find "${LASSOHOME}" \
			-maxdepth 3 \
			\( -iname "*.so" -or -iname "*.bundle" \) \
			-exec chmod 775 "{}" \; > /dev/null 2>&1
	fi

	chmod -R 660 			"${LASSOHOME}"/SQLiteDBs/* > /dev/null 2>&1
	chmod 770 				"${LASSOHOME}"/SQLiteDBs > /dev/null 2>&1
	chown -R lasso:admin 	"${LASSOHOME}"/SQLiteDBs > /dev/null 2>&1

	cd "${HOME}"
	sudo -u lasso env LD_LIBRARY_PATH="/usr/lib/jvm/jre/lib/amd64:/usr/lib/jvm/jre/lib/amd64/server:/usr/lib/jvm/jre/lib/i386:/usr/lib/jvm/jre/lib/i386/server" ./Lasso8Service
fi
