#!/bin/sh

LASSOHOME="/usr/local/Lasso Professional 8"

running=`ps axc | awk "{ if ( \\$5 == \\"Lasso8Service\\" ) print \\$1 }" | tr '\n' '|' | sed -e 's/^\([0-9]*\).*/\1/'`

if [ $running ]; then
	echo ""
	echo "Another instance of Lasso 8.6 Service is already running."
	echo ""
	echo "Please use stopLassoService.command to stop Lasso 8.6 Service."
	echo ""
else

	if [ `id -u` != 0 ]; then
		echo ""
		sudo -p "You must have administrator privileges to run this script.  Enter the password for %u: " "$0" "$@"
	else
		echo ""

		if [ "$1" = "safe" ]; then
			TYPE="SAFE"
		else
			TYPE="NORMAL"
		fi

		echo -n "Starting Lasso 8.6 Service..."

		if [ "$TYPE" = "SAFE" ]; then
			find "${LASSOHOME}" \
				-maxdepth 3 \
				\( -iname "*.so" -or -iname "*.bundle" \) \
				-exec chmod 000 "{}" \; > /dev/null 2>&1
		else
			find "${LASSOHOME}" \
				-maxdepth 3 \
				\( -iname "*.so" -or -iname "*.bundle" \) \
				-exec chmod 775 "{}" \; > /dev/null 2>&1
		fi

		chmod -R 660 			"${LASSOHOME}"/SQLiteDBs/* > /dev/null 2>&1
		chmod 770 				"${LASSOHOME}"/SQLiteDBs > /dev/null 2>&1
		chown -R lasso:admin 	"${LASSOHOME}"/SQLiteDBs > /dev/null 2>&1

		"${LASSOHOME}"/LassoAdmin/Lasso8Service.sh > /dev/null &

		ctime=120
		counter=0
		lassoup=0

		while [ $counter -lt $ctime ] && [ ! -f /tmp/LassoService8.pid ];
		do
			echo -n .
			sleep 1
			counter=$((counter+1))
			if [ -f /tmp/LassoService8.pid ]; then
				lassoup=1
			fi
		done

		lassoservice=`cat /tmp/LassoService8.pid`

		echo "Done [$lassoservice]"
		echo ""

		if [ $lassoup = 1 ] || [ -f /tmp/LassoService8.pid ]; then
			echo "The Lasso 8.6 Service has been started."
			echo ""
			echo "Use stopLassoService.command to stop Lasso 8.6 Service."
		else
			echo "Lasso 8.6 Service did not successfully start in the $ctime second wait time. This could be caused by a datasource host timing out, or the Lasso 8.6 Service suffered a critical error during startup. Run consoleLassoService.command for more information."
		fi
	fi

fi
