#!/bin/sh

LASSOHOME="/usr/local/Lasso Professional 8"

running=`ps axc | awk "{ if ( \\$5 == \\"Lasso8Service\\" ) print \\$1 }" | tr '\n' '|' | sed -e 's/^\([0-9]*\).*/\1/'`

if [ $running ]; then

	if [ `id -u` != 0 ]; then
		echo ""
		sudo  -p "You must have administrator privileges to run this script.  Enter the password for %u: " "$0"
	else
		echo ""

		# kill the lasso shell if it is running
		killall Lasso8Service

		counter=0
		dead=0

		echo -n "Stopping Lasso 8.6 Service..."

		while [ $counter -lt 60 ] && [ $dead = 0 ];
		do
			if [ ! `ps axc | awk "{ if ( \\$5 == \\"Lasso8Service\\" ) print \\$1 }" | tr '\n' '|' | sed -e 's/^\([0-9]*\).*/\1/'` ]; then
				dead=1
			fi
			echo -n "."
			counter=$((counter+1))
			sleep 1
		done

		fail=0

		if [ `ps axc | awk "{ if ( \\$5 == \\"Lasso8Service\\" ) print \\$1 }" | tr '\n' '|' | sed -e 's/^\([0-9]*\).*/\1/'` ]; then
			echo "Fail"
			fail=1
		else
			echo "Done"
		fi

		if [ -f /tmp/LassoService8.pid ] || [ $fail = 1 ]; then
			echo "There was a problem stopping the Lasso 8.6 Service."
		else
			rm -f /tmp/LassoService8.out
			echo "Lasso 8.6 Service has been successfully stopped."
			echo ""
			echo "Use startLassoService.command to restart Lasso 8.6 Service."
		fi
	fi

else

	echo "Lasso 8.6 Service is not running."
	echo ""
	echo "Use startLassoService.command to start Lasso 8.6 Service."

fi
